function y = SolveTriangular(C,pu,pm,pd,lambda_L,lambda_U);

% Solve the system P*C1 = C for the vector C1 using C as input
% Used in the explicit finite difference method

M = (length(C)-1)/2;

pmp(2*M) = pm + pd;
pp(2*M) = C(2*M) + pd*lambda_L;

for j=2*M-1:-1:2
	pmp(j) = pm - pu*pd/pmp(j+1);
	pp(j) = C(j) - pp(j+1)*pd/pmp(j+1);
end

y(1) = (pp(2) + pmp(2)*lambda_U)/(pu + pmp(2));
y(2) = y(1) - lambda_U;

for j=3:2*M;
	y(j) = (pp(j) - pu*y(j-1))/pmp(j);
end

y(2*M+1) = y(2*M) - lambda_L;